/* 
 * Copyright (c) 2000-2001, catchy.net. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *      - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 * 
 *      - Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 *      - All advertising materials mentioning features or use of this software
 *      must display the following acknowledgement: This product includes
 *      software developed by catchy.net and its contributors.
 * 
 *      - Neither name of catchy.net nor the names of its contributors may
 *      be used to endorse or promote products derived from this software
 *      without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY CATCHY.NET AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL CATCHY.NET OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * $Id: StyleList.cpp,v 1.8 2001/01/27 14:36:40 wouter Exp $
 */

#include "StyleList.h"

/** 
 * Constructs a new StyleList object.
 */
StyleList::StyleList():IntList() {
}

/** 
 * Constructs a new StyleList object that is the same as the list in
 * the argument.
 */
StyleList::StyleList(StyleList *sl):IntList(sl) {
}


/**
 * This function tests the code of this class
 *
 * @return  true when all tests succeed, otherwise false
 */
bool StyleList::test() {

  StyleList sl;

  sl.add(4);
  sl.add(2);
  sl.add(1);

  if(sl.getStyle() != 7) 
    return false;

  sl.removeLastAdded();

  if(sl.getStyle() != 6) 
    return false;

  sl.removeLastAdded();
  
  if(sl.getStyle() != 4) 
    return false;

  return true;

}

/**
 * Returns the style you get when all added styles in the list are
 * combined
 * @return the style you get when all added styles in the list are 
 & combined
 */
int StyleList::getStyle() {  
  unsigned int i;
  int style = 0;

  for(i = 0; i < size; i++)
    style |= elements[i];

  return style;

}
