/* 
 * Copyright (c) 2000-2001, catchy.net. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *      - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 * 
 *      - Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 *      - All advertising materials mentioning features or use of this software
 *      must display the following acknowledgement: This product includes
 *      software developed by catchy.net and its contributors.
 * 
 *      - Neither name of catchy.net nor the names of its contributors may
 *      be used to endorse or promote products derived from this software
 *      without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY CATCHY.NET AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL CATCHY.NET OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * $Id: TestWindowDrawingInterface.h,v 1.19 2001/03/24 07:26:51 pascal Exp $
 */

#ifndef __TESTWINDOWDRAWINGINTERFACE_H__
#define __TESTWINDOWDRAWINGINTERFACE_H__

#include "WindowDrawingInterface.h"

/**
 * This class is a platform indepentent class to test the WMLWindow class.
 * Usage:
 * \code
 *   TestWindowDrawingInterface *twdi = new TestWindowDrawingInterface();
 *   WMLWindow *ww = new WMLWindow((WindowDrawingInterface *) twdi);
 *   ww->drawContentWindow(true);
 * \endcode
 */
class TestWindowDrawingInterface : public WindowDrawingInterface {

public:

  TestWindowDrawingInterface();
  virtual ~TestWindowDrawingInterface();
  void setPreferences(MobilizerPreferences *mp);

  void startDrawing(int width, int height);
  void stopDrawing();

  int getStringHeight(String *s, int style);
  int getStringWidth(String *s, int style);
  int getPixelsBelowBaseLine(int style);
  void drawText(String *text, int x, int y, int style);

  GUIPeer* createInputElement();
  void drawInputElement(WMLGUIElement *wie);

  GUIPeer* createSelectElement(PointerList *optionList);
  void drawSelectElement(WMLGUIElement *wse);

  GUIPeer *createImage(WBMP *wbmp);
  void drawImage(WMLGUIElement *image);

};


#endif

