/* 
 * Copyright (c) 2000-2001, catchy.net. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *      - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 * 
 *      - Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 *      - All advertising materials mentioning features or use of this software
 *      must display the following acknowledgement: This product includes
 *      software developed by catchy.net and its contributors.
 * 
 *      - Neither name of catchy.net nor the names of its contributors may
 *      be used to endorse or promote products derived from this software
 *      without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY CATCHY.NET AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL CATCHY.NET OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * $Id: WMLAnchorRectangleList.h,v 1.9 2001/01/27 14:36:40 wouter Exp $
 */

#ifndef __WMLANCHORRECTANGLELIST_H__
#define __WMLANCHORRECTANGLELIST_H__

#include "../lib/Point.h"
class String;

/** 
 * A class representing a list of links that are in the source window.
 * For example:
 * \code
 *  WMLAnchorRectangleList *warl = new WMLAnchorRectangleList();
 *  String *s = new String("http://www.somewhere.com/index.wml");
 *  warl->add(3,3,24,93,s);
 * \endcode
 */
class WMLAnchorRectangleList {

public:

	WMLAnchorRectangleList();
	~WMLAnchorRectangleList();
  static bool test();
  void add(int x1, int y1, int x2, int y2, String *href);
  void clear();
  String* getLinkTarget(int x, int y);

private:
  /* member data */
  
  Point upperLeft;              /**< the upper left point of the rectangle */
  Point lowerRight;             /**< the lower right point of the rectangle */
  String *href;                 /**< the href of the link */
  WMLAnchorRectangleList* next; /**< the next element in the list */

};

#endif
