/* 
 * Copyright (c) 2000-2001, catchy.net. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *      - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 * 
 *      - Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 *      - All advertising materials mentioning features or use of this software
 *      must display the following acknowledgement: This product includes
 *      software developed by catchy.net and its contributors.
 * 
 *      - Neither name of catchy.net nor the names of its contributors may
 *      be used to endorse or promote products derived from this software
 *      without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY CATCHY.NET AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL CATCHY.NET OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * $Id: WMLdtd12.h,v 1.10 2001/01/27 14:36:40 wouter Exp $
 *
 * Reviewed 3-12-2000 ph
 *
 */

#include "DTDDataStructures.h"

/*
 * This struct holds the elements part of the wml 1.2 dtd. For
 * Explanation see DTDDataStructures::Elements.
 */
struct DTDDataStructures::Elements wmleltspec[] = {
 
  {"a",        {{"",0,1}, {"br",0,2}, {"img",0,DTDDataStructures::ok}}},
  {"access",   {{"0",0,DTDDataStructures::ok}}},
  {"anchor",   {{"",0,1}, {"br",0,2}, {"img",0,3}, {"go",0,4}, {"prev",0,5}, {"refresh",0,DTDDataStructures::ok}}},
  {"b",        {{"",0,1}, {"em",0,2}, {"strong",0,3}, {"b",0,4}, {"i",0,5}, {"u",0,6}, {"big",0,7}, {"small",0,8}, {"br",0,9}, {"img",0,10}, {"anchor",0,11}, {"a",0,12}, {"table",0,DTDDataStructures::ok}}},
  {"big",      {{"",0,1}, {"em",0,2}, {"strong",0,3}, {"b",0,4}, {"i",0,5}, {"u",0,6}, {"big",0,7}, {"small",0,8}, {"br",0,9}, {"img",0,10}, {"anchor",0,11}, {"a",0,12}, {"table",0,DTDDataStructures::ok}}},
  {"br",       {{"0",0,DTDDataStructures::ok}}},
  {"card",     {{"onevent",0,1}, {"timer",2,2}, {"do",2,3}, {"p",2,4}, {"pre",2,DTDDataStructures::ok}}},
  {"do",       {{"go",DTDDataStructures::ok,1}, {"prev",DTDDataStructures::ok,2}, {"noop",DTDDataStructures::ok,3}, {"refresh",DTDDataStructures::ok,DTDDataStructures::error}}},
  {"em",       {{"",0,1}, {"em",0,2}, {"strong",0,3}, {"b",0,4}, {"i",0,5}, {"u",0,6}, {"big",0,7}, {"small",0,8}, {"br",0,9}, {"img",0,10}, {"anchor",0,11}, {"a",0,12}, {"table",0,DTDDataStructures::ok}}},
  {"fieldset", {{"",0,1}, {"em",0,2}, {"strong",0,3}, {"b",0,4}, {"i",0,5}, {"u",0,6}, {"big",0,7}, {"small",0,8}, {"br",0,9}, {"img",0,10}, {"anchor",0,11}, {"a",0,12}, {"table",0,13}, {"input",0,14}, {"select",0,15}, {"fieldset",0,16}, {"do",0,DTDDataStructures::ok}}},
  {"go",       {{"postfield",0,1}, {"setvar",0,DTDDataStructures::ok}}},
  {"head",     {{"access",2,1}, {"meta",2,DTDDataStructures::error}, {"access",2,3}, {"meta", 2, DTDDataStructures::ok}}},
  {"i",        {{"",0,1}, {"em",0,2}, {"strong",0,3}, {"b",0,4}, {"i",0,5}, {"u",0,6}, {"big",0,7}, {"small",0,8}, {"br",0,9}, {"img",0,10}, {"anchor",0,11}, {"a",0,12}, {"table",0,DTDDataStructures::ok}}},
  {"img",      {{"0",0,DTDDataStructures::ok}}},
  {"input",    {{"0",0,DTDDataStructures::ok}}},
  {"meta",     {{"0",0,DTDDataStructures::ok}}},
  {"noop",     {{"0",0,DTDDataStructures::ok}}},
  {"onevent",  {{"go",DTDDataStructures::ok,1}, {"prev",DTDDataStructures::ok,2}, {"noop",DTDDataStructures::ok,3}, {"refresh", DTDDataStructures::ok, DTDDataStructures::error}}},
  {"optgroup", {{"optgroup",2,1}, {"option",2,DTDDataStructures::error}, {"optgroup",2,3}, {"option", 2, DTDDataStructures::ok}}},
  {"option",   {{"",0,1}, {"onevent",0,DTDDataStructures::ok}}},
  {"p",        {{"",0,1}, {"em",0,2}, {"strong",0,3}, {"b",0,4}, {"i",0,5}, {"u",0,6}, {"big",0,7}, {"small",0,8}, {"br",0,9}, {"img",0,10}, {"anchor",0,11}, {"a",0,12}, {"table",0,13}, {"input",0,14}, {"select",0,15}, {"fieldset",0,16}, {"do",0,DTDDataStructures::ok}}},
  {"postfield",{{"0",0,DTDDataStructures::ok}}},
  {"pre",      {{"",0,1}, {"a",0,2}, {"br",0,3}, {"i",0,4}, {"b",0,5}, {"em",0,6}, {"strong",0,7}, {"input",0,8}, {"select",0,DTDDataStructures::ok}}},
  {"prev",     {{"setvar",0,DTDDataStructures::ok}}},
  {"refresh",  {{"setvar",0,DTDDataStructures::ok}}},
  {"setvar",   {{"0",0,DTDDataStructures::ok}}},
  {"select",   {{"optgroup",2,1}, {"option",2,DTDDataStructures::error}, {"optgroup",2,3}, {"option", 2, DTDDataStructures::ok}}},
  {"small",    {{"",0,1}, {"em",0,2}, {"strong",0,3}, {"b",0,4}, {"i",0,5}, {"u",0,6}, {"big",0,7}, {"small",0,8}, {"br",0,9}, {"img",0,10}, {"anchor",0,11}, {"a",0,12}, {"table",0,DTDDataStructures::ok}}},
  {"strong",   {{"",0,1}, {"em",0,2}, {"strong",0,3}, {"b",0,4}, {"i",0,5}, {"u",0,6}, {"big",0,7}, {"small",0,8}, {"br",0,9}, {"img",0,10}, {"anchor",0,11}, {"a",0,12}, {"table",0,DTDDataStructures::ok}}},
  {"table",    {{"tr",1,DTDDataStructures::error}, {"tr",1,DTDDataStructures::ok}}},
  {"td",       {{"",0,1}, {"em",0,2}, {"strong",0,3}, {"b",0,4}, {"i",0,5}, {"u",0,6}, {"big",0,7}, {"small",0,8}, {"br",0,9}, {"img",0,10}, {"anchor",0,11}, {"a",0,DTDDataStructures::ok}}},
  {"template", {{"do",0,1}, {"onevent",0,DTDDataStructures::ok}}},
  {"timer",    {{"0",0,DTDDataStructures::ok}}},
  {"tr",       {{"td",1,DTDDataStructures::error}, {"td",1,DTDDataStructures::ok}}},
  {"u",        {{"",0,1}, {"em",0,2}, {"strong",0,3}, {"b",0,4}, {"i",0,5}, {"u",0,6}, {"big",0,7}, {"small",0,8}, {"br",0,9}, {"img",0,10}, {"anchor",0,11}, {"a",0,12}, {"table",0,DTDDataStructures::ok}}},
  {"wml",      {{"head",1,1}, {"template",2,2}, {"card",3,DTDDataStructures::error}, {"card",3,DTDDataStructures::ok}}}

};

/**
 * These are the types of attributes that are possible in a wml 1.2
 * xml document.
 *
 * type         image value must be
 *************************************
 * ignored      deleted from parsetree
 * cdata        something
 * booleans     true or false
 * gomethod     post or get
 * length       ['0'-'9']+'%'?
 * imgalign     top, middle or bottom
 * inputtype    text or password
 * number       [0-9]+
 * wrapmode     wrap or nowrap
 * palign       left, center or right
 */
class WMLAttributeType {
public:
  enum {
    ignored,
    cdata,
    booleans,
    gomethod,
    length,
    imgalign,
    inputtype,
    number,
    wrapmode,
    palign
  };
};

/*
 * This struct holds the attributes part of the wml 1.2 dtd. For
 * Explanation see DTDDataStructures::Attributes.
 */
struct DTDDataStructures::Attributes wmlattrspec[] = {

  {"a",        {{"href"}},{{""}},{{"href",WMLAttributeType::cdata},{"title",WMLAttributeType::cdata},{"accesskey",WMLAttributeType::cdata},{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"access",   {{""}},{{""}},{{"domain",WMLAttributeType::cdata},{"path",WMLAttributeType::cdata},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"anchor",   {{""}},{{""}},{{"title",WMLAttributeType::cdata},{"accesskey",WMLAttributeType::cdata},{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"b",        {{""}},{{""}},{{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"big",      {{""}},{{""}},{{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"br",       {{""}},{{""}},{{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"card",     {{""}},{{"newcontext","false"},{"ordered","true"}},{{"title",WMLAttributeType::cdata},{"newcontext",WMLAttributeType::booleans},{"ordered",WMLAttributeType::booleans},{"onenterforward",WMLAttributeType::cdata},{"onenterbackward",WMLAttributeType::cdata},{"ontimer",WMLAttributeType::cdata},{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::cdata},{"class",WMLAttributeType::ignored}}},
  {"do",       {{"type"}},{{"optional","false"}},{{"type",WMLAttributeType::cdata},{"label",WMLAttributeType::cdata},{"name",WMLAttributeType::cdata},{"optional",WMLAttributeType::booleans},{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"em",       {{""}},{{""}},{{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"fieldset", {{""}},{{""}},{{"title",WMLAttributeType::cdata},{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"go",       {{"href"}},{{"sendreferer","false"},{"method","get"}},{{"href",WMLAttributeType::cdata},{"sendreferer",WMLAttributeType::booleans},{"method",WMLAttributeType::gomethod},{"enctype",WMLAttributeType::ignored},{"accept-charset",WMLAttributeType::cdata},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"head",     {{""}},{{""}},{{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"i",        {{""}},{{""}},{{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"img",      {{"alt"},{"src"}},{{"vspace","0"},{"hspace","0"},{"align","bottom"}},{{"alt",WMLAttributeType::cdata},{"src",WMLAttributeType::cdata},{"localsrc",WMLAttributeType::cdata},{"vspace",WMLAttributeType::length},{"hspace",WMLAttributeType::length},{"align",WMLAttributeType::imgalign},{"height",WMLAttributeType::length},{"width",WMLAttributeType::length},{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"input",    {{"name"}},{{"type","text"},{"emptyok","false"}},{{"name",WMLAttributeType::cdata},{"type",WMLAttributeType::inputtype},{"value",WMLAttributeType::cdata},{"format",WMLAttributeType::cdata},{"emptyok",WMLAttributeType::cdata},{"size",WMLAttributeType::number},{"maxlength",WMLAttributeType::number},{"tabindex",WMLAttributeType::number},{"title",WMLAttributeType::cdata},{"accesskey",WMLAttributeType::cdata},{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"meta",     {{"content"}},{{"forua","false"}},{{"http-equiv",WMLAttributeType::cdata},{"name",WMLAttributeType::cdata},{"forua",WMLAttributeType::booleans},{"content",WMLAttributeType::cdata},{"scheme",WMLAttributeType::cdata},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"noop",     {{""}},{{""}},{{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"onevent",  {{"type"}},{{""}},{{"type",WMLAttributeType::cdata},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"optgroup", {{""}},{{""}},{{"title",WMLAttributeType::cdata},{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"option",   {{""}},{{""}},{{"value",WMLAttributeType::cdata},{"title",WMLAttributeType::cdata},{"onpick",WMLAttributeType::cdata},{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"p",        {{""}},{{"align","left"}},{{"align",WMLAttributeType::palign},{"mode",WMLAttributeType::wrapmode},{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"postfield",{{"name"},{"value"}},{{""}},{{"name",WMLAttributeType::cdata},{"value",WMLAttributeType::cdata},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"pre",      {{""}},{{""}},{{"xml:space",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"prev",     {{""}},{{""}},{{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"refresh",  {{""}},{{""}},{{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"setvar",   {{"name"},{"value"}},{{""}},{{"name",WMLAttributeType::cdata},{"value",WMLAttributeType::cdata},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"select",   {{""}},{{"multiple","false"}},{{"title",WMLAttributeType::cdata},{"name",WMLAttributeType::cdata},{"value",WMLAttributeType::cdata},{"iname",WMLAttributeType::cdata},{"ivalue",WMLAttributeType::cdata},{"multiple",WMLAttributeType::booleans},{"tabindex",WMLAttributeType::number},{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"small",    {{""}},{{""}},{{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"strong",   {{""}},{{""}},{{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"table",    {{"columns"}},{{""}},{{"title",WMLAttributeType::cdata},{"align",WMLAttributeType::cdata},{"columns",WMLAttributeType::number},{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"td",       {{""}},{{""}},{{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"template", {{""}},{{""}},{{"onenterforward",WMLAttributeType::cdata},{"onenterbackward",WMLAttributeType::cdata},{"ontimer",WMLAttributeType::cdata},{"id",WMLAttributeType::cdata},{"class",WMLAttributeType::ignored}}},
  {"timer",    {{"value"}},{{""}},{{"name",WMLAttributeType::cdata},{"value",WMLAttributeType::cdata},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"tr",       {{""}},{{""}},{{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"u",        {{""}},{{""}},{{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}},
  {"wml",      {{""}},{{""}},{{"xml:lang",WMLAttributeType::ignored},{"id",WMLAttributeType::ignored},{"class",WMLAttributeType::ignored}}}

};
